/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package motorbusqueda;

import com.mysql.jdbc.Connection;
import com.mysql.jdbc.PreparedStatement;
import java.io.IOException;
import java.math.BigInteger;
import java.net.URL;
import java.security.SecureRandom;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Properties;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

/**
 *
 * @author ing_a_000
 */
public class MotorHilo extends Thread{
    
    static int cont = 0;
    
    @Override
    public void run(){
        cont++;
        String nombre = nextSessionId()+"";
        System.out.println("Hilo "+nombre+" iniciado");
        while (true){
            String enlaceInicial = obtenerEnlace(nombre);
            extraerEnlacesURL(enlaceInicial);
        }
    }
    
    private static String obtenerEnlace(String nombre){
        String enlace = "";
        try{
            Class.forName("com.mysql.jdbc.Driver");
            Properties p = new Properties();
            p.put("user", "root");
            p.put("password", "");
            Connection conn = (Connection) DriverManager.getConnection("jdbc:mysql://localhost:3306/buscador?allowMultiQueries=true", p);
            
            //La sentencia mysql
            String sql = "UPDATE enlaces SET estado = '"+nombre+"' WHERE estado = 'pendiente' LIMIT 1";
            PreparedStatement preparada = (PreparedStatement) conn.prepareStatement(sql);
            preparada.executeUpdate();
            //Selecciona el enlace
            sql = "SELECT * FROM enlaces WHERE estado = '"+nombre+"' LIMIT 1";
            //Crea la sentencia preparada
            preparada = (PreparedStatement) conn.prepareStatement(sql);
            
            ResultSet res = preparada.executeQuery();
            while(res.next()){
                enlace = res.getString("enlace");
                System.out.println(nombre+" -> "+enlace);
            }
            
            sql = "UPDATE enlaces SET estado = 'revisado' WHERE enlace = '"+enlace+"'";
            preparada = (PreparedStatement) conn.prepareStatement(sql);
            preparada.execute();
            
            conn.close();
        }catch (SQLException ex) {
            // handle any errors
            //ex.printStackTrace();
            //System.out.println("SQLException: " + ex.getMessage());
            //System.out.println("SQLState: " + ex.getSQLState());
            //System.out.println("VendorError: " + ex.getErrorCode());
        } catch (ClassNotFoundException e) {
            //e.printStackTrace();
        }
        return enlace;
    }
    
    private static void extraerEnlacesURL(String URL){
        String sitio = "";
        
        try {
            URL myURL = new URL(URL);
            sitio = myURL.getHost();
            Document doc = Jsoup.connect(URL).get();
            Elements links = doc.getElementsByTag("a");
            for (Element link : links){
                String linkHref = link.attr("href");
                if (!linkHref.equalsIgnoreCase("") && !linkHref.equalsIgnoreCase("#")){
                    if (fastCmp(linkHref, "http") || fastCmp(linkHref, "www.")){
                        linkHref = extraerJavascript(linkHref);
                        insertaEnlace(sitio, linkHref);
                    }
                    else
                        insertaEnlace(sitio, "http://"+sitio+"/"+linkHref);
                }
            }
        } catch (IOException e) {
            //e.printStackTrace();
        }
    }
    
    private static void insertaEnlace(String sitio, String enlace) {
        try{
            Class.forName("com.mysql.jdbc.Driver");
            Properties p = new Properties();
            p.put("user", "root");
            p.put("password", "");
            Connection conn = (Connection) DriverManager.getConnection("jdbc:mysql://localhost:3306/buscador", p);

            //La sentencia mysql
            String sql = "INSERT INTO enlaces (sitio, enlace, estado) VALUES(?, ?, ?)";

            //Crea la sentencia preparada
            PreparedStatement preparada = (PreparedStatement) conn.prepareStatement(sql);
            preparada.setString(1, sitio);
            preparada.setString(2, enlace);
            preparada.setString(3, "pendiente");

            //ejecutamos la sentencia
            preparada.execute();

            conn.close();
        }catch (SQLException ex) {
            // handle any errors
            //ex.printStackTrace();
            //System.out.println("SQLException: " + ex.getMessage());
            //System.out.println("SQLState: " + ex.getSQLState());
            //System.out.println("VendorError: " + ex.getErrorCode());
        } catch (ClassNotFoundException e) {
            //e.printStackTrace();
        }
    }
    
    static boolean fastCmp(String s1, String s2) {
        return s1.regionMatches(0, s2, 0, 4);
    }
    
    static String extraerJavascript(String link){
        int index = link.indexOf("javascript:");
        if (index > -1){
            System.out.println("Extrayendo de "+link);
            System.out.println(index);
            link = link.substring(0, index - 1);
            System.out.println("Resultado : "+link);
        }
        return link;
    }
    
    private SecureRandom random = new SecureRandom();

    public String nextSessionId() {
      return new BigInteger(130, random).toString(32);
    }
    
}
